準(zhǔn)備環(huán)境或工具
Nodejs:?jiǎn)?dòng)項(xiàng)目需要的環(huán)境
pm2:?jiǎn)?dòng)項(xiàng)目為守護(hù)進(jìn)程
Nginx:映射到相應(yīng)的域名
ps:我的Linux系統(tǒng)為Ubuntu16.04蜓堕,安裝Nginx可能會(huì)與其他版本的Linux有點(diǎn)差別
一. Linux系統(tǒng)安裝Nodejs
- 通過(guò)
uname -a
命令查看到我的Linux系統(tǒng)位數(shù)是64位(備注:x86_64表示64位系統(tǒng)铡恕, i686 i386表示32位系統(tǒng))
root@genuine-spin-3:~# uname -a
Linux genuine-spin-3.localdomain 4.10.0-22-generic #24~16.04.1-Ubuntu SMP Tue May 23 17:03:51 UTC 2017 x86_64 x86_64 x86_64 GNU/Linux
-
去下面官網(wǎng)找到和自己系統(tǒng)匹配的文件,按F12拿到文件下載地址:
英文網(wǎng)址:https://nodejs.org/en/download/
中文網(wǎng)址:http://nodejs.cn/download/
用
wget
命令把Nodejs文件下載下來(lái),放置路徑為/usr/local/
,然后解壓Nodejs文件(為了方便,我還將文件改名為nodejs,這步可省略)
root@genuine-spin-3:~# cd /usr/local/
root@genuine-spin-3:/usr/local# wget https://nodejs.org/dist/v10.16.1/node-v10.16.1-linux-x64.tar.xz
root@genuine-spin-3:/usr/local# tar -xvf node-v10.16.1-linux-x64.tar.xz
root@genuine-spin-3:/usr/local# mv node-v6.10.0-linux-x64 nodejs
5.確認(rèn)一下nodejs下bin目錄是否有node 和npm文件玫坛,(執(zhí)行 ./node -v
也能確定nodejs是否安裝成功),如果有问顷,執(zhí)行軟連接昂秃,變?yōu)槿郑绻麤](méi)有重新下載
root@genuine-spin-3:~# cd /usr/local/nodejs/bin
root@genuine-spin-3:/usr/local/nodejs/bin# ls
node npm npx
root@genuine-spin-3:/usr/local/nodejs/bin# ./node -v
v10.16.1
root@genuine-spin-3:/usr/local/nodejs/bin# ln -s /usr/local/nodejs/bin/node /usr/local/bin/
root@genuine-spin-3:/usr/local/nodejs/bin# ln -s /usr/local/nodejs/bin/npm /usr/local/bin/
-
node -v
檢驗(yàn)nodejs是否已變?yōu)槿?/li>
root@genuine-spin-3:/usr/local/nodejs/bin# node -v
v10.16.1
二. Linux系統(tǒng)安裝pm2
啟動(dòng)項(xiàng)目為守護(hù)進(jìn)程杜窄,我選擇了強(qiáng)大的 pm2肠骆,具體原因可以參考大佬的網(wǎng)頁(yè):http://www.ruanyifeng.com/blog/2016/02/linux-daemon.html
安裝pm2
npm install pm2 -g
執(zhí)行下面軟連接,全局安裝pm2
ln -s /rusr/local/nodejs/pm2 /usr/local/bin/
(ps:安裝pm2時(shí)打印的log可以看到pm2安裝的位置)執(zhí)行
pm2 start server.js --watch
啟動(dòng)項(xiàng)目
pm2的一些常用命令:
pm2 start server.js // 啟動(dòng) server.js應(yīng)用程序
pm2 start server.js --name sell // 啟動(dòng) server.js應(yīng)用程序并命名為 sell
pm2 start server.js --watch // 當(dāng)文件變化時(shí)自動(dòng)重啟應(yīng)用
pm2 restart all // 重啟所有應(yīng)用
pm2 stop server.js // 停止 server.js的應(yīng)用程序
pm2 stop sell // 停止 naem為 sell 的應(yīng)用程序
pm2 stop 0 // 停止 id為 0 的應(yīng)用程序
pm2 stop all // 停止所有的應(yīng)用程序
pm2 delete 0 // 刪除指定應(yīng)用 id為 0
pm2 delete all // 關(guān)閉并刪除所有應(yīng)用
pm2 list // pm2啟動(dòng)的所有的應(yīng)用程序列表
三. Ubuntu16.04 安裝Nginx
在Ubuntu下安裝Nginx有以下兩種方法塞耕,但是如果想要安裝最新版本的就必須下載源碼包編譯安裝蚀腿。
apt-get install nginx
安裝好的文件位置:
/usr/sbin/nginx
:主程序
/etc/nginx
:存放配置文件
/usr/share/nginx
:存放靜態(tài)文件
/var/log/nginx
:存放日志
其實(shí)從上面的根目錄文件夾可以知道,Linux系統(tǒng)的配置文件一般放在/etc
扫外,日志一般放在/var/log
莉钙,運(yùn)行的程序一般放在/usr/sbin
或者/usr/bin
。
當(dāng)然筛谚,如果要更清楚Nginx的配置項(xiàng)放在什么地方磁玉,可以打開(kāi)/etc/nginx/nginx.conf
如果要查看加載的是哪個(gè)配置文件,可以用這個(gè)命令nginx -t
或者ps -ef | grep nginx
通過(guò)這種方式安裝的驾讲,會(huì)自動(dòng)創(chuàng)建服務(wù)蚊伞,會(huì)自動(dòng)在/etc/init.d/nginx
新建服務(wù)腳本席赂,然后就可以使用service nginx {start|stop|restart|reload|force-reload|status|configtest|rotate|upgrade}
的命令啟動(dòng)。
還有一個(gè)好處时迫,創(chuàng)建好的文件由于放在/usr/sbin
目錄下颅停,所以能直接在終端中使用nginx命令而無(wú)需指定路徑。
寫在安裝前:
這種方式可以自定安裝指定的模塊以及最新的版本掠拳。方式更靈活癞揉。
官方下載頁(yè)面:http://nginx.org/en/download.html
configure配置文件詳解:http://nginx.org/en/docs/configure.html
1. 首先安裝缺少的依賴包
安裝gcc g++的依賴庫(kù)
apt-get install build-essential
apt-get install libtool
安裝pcre依賴庫(kù)(http://www.pcre.org/)
apt-get update
apt-get install libpcre3 libpcre3-dev
安裝zlib依賴庫(kù)(http://www.zlib.net)
apt-get install zlib1g-dev
安裝SSL依賴庫(kù)(16.04默認(rèn)已經(jīng)安裝了)
apt-get install openssl
2. 安裝Nginx
#下載最新版本:
wget http://nginx.org/download/nginx-1.13.6.tar.gz
#解壓:
tar -zxvf nginx-1.13.6.tar.gz
#進(jìn)入解壓目錄:
cd nginx-1.13.6
#配置:
./configure --prefix=/usr/local/nginx
#編譯:
make
#安裝:
make install
#啟動(dòng):
/usr/local/nginx/sbin/nginx -c /usr/local/nginx/conf/nginx.conf
注意:-c 指定配置文件的路徑,不加的話溺欧,nginx會(huì)自動(dòng)加載默認(rèn)路徑的配置文件喊熟,可以通過(guò)-h查看幫助命令。
#查看進(jìn)程:
ps -ef | grep nginx
3. 配置軟鏈接
ln -s /usr/local/nginx/sbin/nginx /usr/bin/nginx
現(xiàn)在就可以不用路徑直接輸入nginx啟動(dòng)姐刁。
4. 配置開(kāi)機(jī)啟動(dòng)服務(wù)
在/etc/init.d/下創(chuàng)建nginx文件逊移,sudo vim /etc/init.d/nginx,內(nèi)容如下:
#!/bin/sh
### BEGIN INIT INFO
# Provides: nginx
# Required-Start: $local_fs $remote_fs $network $syslog $named
# Required-Stop: $local_fs $remote_fs $network $syslog $named
# Default-Start: 2 3 4 5
# Default-Stop: 0 1 6
# Short-Description: starts the nginx web server
# Description: starts nginx using start-stop-daemon
### END INIT INFO
PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
DAEMON=/usr/local/nginx/sbin/nginx
NAME=nginx
DESC=nginx
# Include nginx defaults if available
if [ -r /etc/default/nginx ]; then
. /etc/default/nginx
fi
STOP_SCHEDULE="${STOP_SCHEDULE:-QUIT/5/TERM/5/KILL/5}"
test -x $DAEMON || exit 0
. /lib/init/vars.sh
. /lib/lsb/init-functions
# Try to extract nginx pidfile
PID=$(cat /usr/local/nginx/conf/nginx.conf | grep -Ev '^\s*#' | awk 'BEGIN { RS="[;{}]" } { if ($1 == "pid") print $2 }' | head -n1)
if [ -z "$PID" ]; then
PID=/run/nginx.pid
fi
if [ -n "$ULIMIT" ]; then
# Set ulimit if it is set in /etc/default/nginx
ulimit $ULIMIT
fi
start_nginx() {
# Start the daemon/service
#
# Returns:
# 0 if daemon has been started
# 1 if daemon was already running
# 2 if daemon could not be started
start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON --test > /dev/null \
|| return 1
start-stop-daemon --start --quiet --pidfile $PID --exec $DAEMON -- \
$DAEMON_OPTS 2>/dev/null \
|| return 2
}
test_config() {
# Test the nginx configuration
$DAEMON -t $DAEMON_OPTS >/dev/null 2>&1
}
stop_nginx() {
# Stops the daemon/service
#
# Return
# 0 if daemon has been stopped
# 1 if daemon was already stopped
# 2 if daemon could not be stopped
# other if a failure occurred
start-stop-daemon --stop --quiet --retry=$STOP_SCHEDULE --pidfile $PID --name $NAME
RETVAL="$?"
sleep 1
return "$RETVAL"
}
reload_nginx() {
# Function that sends a SIGHUP to the daemon/service
start-stop-daemon --stop --signal HUP --quiet --pidfile $PID --name $NAME
return 0
}
rotate_logs() {
# Rotate log files
start-stop-daemon --stop --signal USR1 --quiet --pidfile $PID --name $NAME
return 0
}
upgrade_nginx() {
# Online upgrade nginx executable
# http://nginx.org/en/docs/control.html
#
# Return
# 0 if nginx has been successfully upgraded
# 1 if nginx is not running
# 2 if the pid files were not created on time
# 3 if the old master could not be killed
if start-stop-daemon --stop --signal USR2 --quiet --pidfile $PID --name $NAME; then
# Wait for both old and new master to write their pid file
while [ ! -s "${PID}.oldbin" ] || [ ! -s "${PID}" ]; do
cnt=`expr $cnt + 1`
if [ $cnt -gt 10 ]; then
return 2
fi
sleep 1
done
# Everything is ready, gracefully stop the old master
if start-stop-daemon --stop --signal QUIT --quiet --pidfile "${PID}.oldbin" --name $NAME; then
return 0
else
return 3
fi
else
return 1
fi
}
case "$1" in
start)
log_daemon_msg "Starting $DESC" "$NAME"
start_nginx
case "$?" in
0|1) log_end_msg 0 ;;
2) log_end_msg 1 ;;
esac
;;
stop)
log_daemon_msg "Stopping $DESC" "$NAME"
stop_nginx
case "$?" in
0|1) log_end_msg 0 ;;
2) log_end_msg 1 ;;
esac
;;
restart)
log_daemon_msg "Restarting $DESC" "$NAME"
# Check configuration before stopping nginx
if ! test_config; then
log_end_msg 1 # Configuration error
exit $?
fi
stop_nginx
case "$?" in
0|1)
start_nginx
case "$?" in
0) log_end_msg 0 ;;
1) log_end_msg 1 ;; # Old process is still running
*) log_end_msg 1 ;; # Failed to start
esac
;;
*)
# Failed to stop
log_end_msg 1
;;
esac
;;
reload|force-reload)
log_daemon_msg "Reloading $DESC configuration" "$NAME"
# Check configuration before stopping nginx
#
# This is not entirely correct since the on-disk nginx binary
# may differ from the in-memory one, but that's not common.
# We prefer to check the configuration and return an error
# to the administrator.
if ! test_config; then
log_end_msg 1 # Configuration error
exit $?
fi
reload_nginx
log_end_msg $?
;;
configtest|testconfig)
log_daemon_msg "Testing $DESC configuration"
test_config
log_end_msg $?
;;
status)
status_of_proc -p $PID "$DAEMON" "$NAME" && exit 0 || exit $?
;;
upgrade)
log_daemon_msg "Upgrading binary" "$NAME"
upgrade_nginx
log_end_msg $?
;;
rotate)
log_daemon_msg "Re-opening $DESC log files" "$NAME"
rotate_logs
log_end_msg $?
;;
*)
echo "Usage: $NAME {start|stop|restart|reload|force-reload|status|configtest|rotate|upgrade}" >&2
exit 3
;;
esac
設(shè)置服務(wù)腳本有執(zhí)行權(quán)限
chmod +x /etc/init.d/nginx
注冊(cè)服務(wù)
cd /etc/init.d/
update-rc.d nginx defaults
現(xiàn)在基本上就可以開(kāi)機(jī)啟動(dòng)了龙填,常用的命令如下:
service nginx {start|stop|restart|reload|force-reload|status|configtest|rotate|upgrade}
四. Nginx的配置
- 了解nginx.conf 配置結(jié)構(gòu)
... #全局塊
events { #events塊
...
}
http #http塊
{
... #http全局塊
server #server塊
{
... #server全局塊
location [PATTERN] #location塊
{
...
}
location [PATTERN]
{
...
}
}
server
{
...
}
... #http全局塊
}
1、main全局塊:配置影響nginx全局的指令拐叉。一般有運(yùn)行nginx服務(wù)器的用戶組岩遗,nginx進(jìn)程pid存放路徑,日志存放路徑凤瘦,配置文件引入宿礁,允許生成worker process數(shù)等。
2蔬芥、events塊:配置影響nginx服務(wù)器或與用戶的網(wǎng)絡(luò)連接梆靖。有每個(gè)進(jìn)程的最大連接數(shù),選取哪種事件驅(qū)動(dòng)模型處理連接請(qǐng)求笔诵,是否允許同時(shí)接受多個(gè)網(wǎng)路連接返吻,開(kāi)啟多個(gè)網(wǎng)絡(luò)連接序列化等。
3乎婿、http塊:可以嵌套多個(gè)server测僵,配置代理,緩存谢翎,日志定義等絕大多數(shù)功能和第三方模塊的配置捍靠。如文件引入,mime-type定義森逮,日志自定義榨婆,是否使用sendfile傳輸文件,連接超時(shí)時(shí)間褒侧,單連接請(qǐng)求數(shù)等良风。
4谊迄、server塊:配置虛擬主機(jī)的相關(guān)參數(shù),一個(gè)http中可以有多個(gè)server拖吼。
5鳞上、location塊:配置請(qǐng)求的路由,以及各種頁(yè)面的處理情況吊档。
不同模塊指令關(guān)系:server繼承main篙议;location繼承server;upstream既不會(huì)繼承指令也不會(huì)被繼承怠硼,它有自己的特殊指令鬼贱,不需要在其他地方的應(yīng)用
- nginx.conf 配置文件如下:
#配置用戶或者組,默認(rèn)為nobody nobody香璃。
#user nobody;
#允許生成的進(jìn)程數(shù)这难,默認(rèn)為1
worker_processes 1;
#制定錯(cuò)誤日志路徑,級(jí)別葡秒。這個(gè)設(shè)置可以放入全局塊姻乓,http塊,server塊眯牧,級(jí)別依次為:debug|info|notice|warn|error|crit|alert|emerg
#error_log logs/error.log;
#error_log logs/error.log notice;
#error_log logs/error.log info;
#指定nginx進(jìn)程運(yùn)行文件存放地址
#pid logs/nginx.pid;
#工作模式及連接數(shù)上限
events {
#單個(gè)work進(jìn)程允許的最大連接數(shù)蹋岩,默認(rèn)為512
worker_connections 1024;
}
#http服務(wù)器
http {
#文件擴(kuò)展名與文件類型映射表。設(shè)定mime類型(郵件支持類型),類型由mime.types文件定義
#include /usr/local/nginx/conf/mime.types;
include mime.types;
#默認(rèn)文件類型学少,默認(rèn)為text/plain
default_type application/octet-stream;
#自定義日志格式
#log_format main '$remote_addr - $remote_user [$time_local] "$request" '
# '$status $body_bytes_sent "$http_referer" '
# '"$http_user_agent" "$http_x_forwarded_for"';
#設(shè)置訪問(wèn)日志路徑和格式剪个。"log/"該路徑為nginx日志的相對(duì)路徑,mac下是/usr/local/var/log/版确。combined為日志格式的默認(rèn)值
#access_log logs/access.log main;
#允許sendfile方式傳輸文件扣囊,默認(rèn)為off,可以在http塊绒疗,server塊侵歇,location塊。(sendfile系統(tǒng)調(diào)用不需要將數(shù)據(jù)拷貝或者映射到應(yīng)用程序地址空間中去)
sendfile on;
#tcp_nopush on;
#連接超時(shí)時(shí)間忌堂,默認(rèn)為75s盒至,可以在http,server士修,location塊枷遂。
#keepalive_timeout 0;
keepalive_timeout 65;
#gzip壓縮開(kāi)關(guān)
#gzip on;
#HTTP服務(wù)器
# 靜態(tài)資源一般放在nginx所在主機(jī)
server {
listen 80; #監(jiān)聽(tīng)HTTP端口
server_name guirong.name; #監(jiān)聽(tīng)基于域名的虛擬主機(jī)∑宄埃可有多個(gè)酒唉,可以使用正則表達(dá)式和通配符
#charset koi8-r;
#access_log logs/host.access.log main;
location / {
rewrite ^/ http://www.guirong.name;
}
location /sell/ { #反向代理的路徑(和upstream綁定),location后面設(shè)置映射的路徑
proxy_set_header X-Real-IP $remote_addr;
proxy_set_header X-Forwarded-For $proxy_add_x_forwarded_for;
proxy_set_header Host $http_host;
proxy_set_header X-Nginx-Proxy true;
proxy_pass http://127.0.0.1:8090/;
}
# 指定某些路徑使用https訪問(wèn)(使用正則表達(dá)式匹配路徑+重寫uri路徑)
location ~* /http* { #路徑匹配規(guī)則:如localhost/http沸移、localhost/httpsss等等
#rewrite只能對(duì)域名后邊的除去傳遞的參數(shù)外的字符串起作用痪伦,例如www.c.com/proxy/html/api/msg?method=1¶=2只能對(duì)/proxy/html/api/msg重寫侄榴。
#rewrite 規(guī)則 定向路徑 重寫類型;
#rewrite后面的參數(shù)是一個(gè)簡(jiǎn)單的正則。$1代表正則中的第一個(gè)()网沾。
#$host是nginx內(nèi)置全局變量癞蚕,代表請(qǐng)求的主機(jī)名
#重寫規(guī)則permanent表示返回301永久重定向
rewrite ^/(.*)$ https://$host/$1 permanent;
}
#錯(cuò)誤處理頁(yè)面(可選擇性配置)
#error_page 404 /404.html;
# redirect server error pages to the static page /50x.html
#
error_page 500 502 503 504 /50x.html;
location = /50x.html {
root html;
}
# proxy the PHP scripts to Apache listening on 127.0.0.1:80
#
#location ~ \.php$ {
# proxy_pass http://127.0.0.1;
#}
# pass the PHP scripts to FastCGI server listening on 127.0.0.1:9000
#
#location ~ \.php$ {
# root html;
# fastcgi_pass 127.0.0.1:9000;
# fastcgi_index index.php;
# fastcgi_param SCRIPT_FILENAME /scripts$fastcgi_script_name;
# include fastcgi_params;
#}
# deny access to .htaccess files, if Apache's document root
# concurs with nginx's one
#
#location ~ /\.ht {
# deny all;
#}
}
#以下是一些反向代理的配置(可選擇性配置)
#proxy_redirect off;
#proxy_set_header Host $host; #proxy_set_header用于設(shè)置發(fā)送到后端服務(wù)器的request的請(qǐng)求頭
#proxy_set_header X-Real-IP $remote_addr;
#proxy_set_header X-Forwarded-For $remote_addr; #后端的Web服務(wù)器可以通過(guò)X-Forwarded-For獲取用戶真實(shí)IP
#proxy_connect_timeout 90; #nginx跟后端服務(wù)器連接超時(shí)時(shí)間(代理連接超時(shí))
#proxy_send_timeout 90; #后端服務(wù)器數(shù)據(jù)回傳時(shí)間(代理發(fā)送超時(shí))
#proxy_read_timeout 90; #連接成功后,后端服務(wù)器響應(yīng)時(shí)間(代理接收超時(shí))
#proxy_buffer_size 4k; #設(shè)置代理服務(wù)器(nginx)保存用戶頭信息的緩沖區(qū)大小
#proxy_buffers 4 32k; #proxy_buffers緩沖區(qū)辉哥,網(wǎng)頁(yè)平均在32k以下的話桦山,這樣設(shè)置
#proxy_busy_buffers_size 64k; #高負(fù)荷下緩沖大小(proxy_buffers*2)
#proxy_temp_file_write_size 64k; #設(shè)定緩存文件夾大小醋旦,大于這個(gè)值恒水,將從upstream服務(wù)器傳
#client_max_body_size 10m; #允許客戶端請(qǐng)求的最大單文件字節(jié)數(shù)
#client_body_buffer_size 128k; #緩沖區(qū)代理緩沖用戶端請(qǐng)求的最大字節(jié)數(shù)
# another virtual host using mix of IP-, name-, and port-based configuration
#
#server {
# listen 8000;
# listen somename:8080;
# server_name somename alias another.alias;
# location / {
# root html;
# index index.html index.htm;
# }
#}
#https
#(1)HTTPS的固定端口號(hào)是443,不同于HTTP的80端口饲齐;
#(2)SSL標(biāo)準(zhǔn)需要引入安全證書(shū)钉凌,所以在 nginx.conf 中你需要指定證書(shū)和它對(duì)應(yīng)的 key
# HTTPS server
#
server {
listen 443 ssl;
server_name localhost;
ssl_certificate cert.pem; #ssl證書(shū)文件位置(常見(jiàn)證書(shū)文件格式為:crt/pem)
ssl_certificate_key cert.key; #ssl證書(shū)key位置
#ssl配置參數(shù)(選擇性配置)
ssl_session_cache shared:SSL:1m;
ssl_session_timeout 5m;
ssl_ciphers HIGH:!aNULL:!MD5;
ssl_prefer_server_ciphers on;
location / {
root html;
index index.html index.htm;
}
}
#可以把子配置文件放到/usr/local/etc/nginx/servers/路徑下,通過(guò)include引入
#include /usr/local/etc/nginx/servers/*.conf;
}
- 按照上面配置完nginx.conf 文件之后就可以通過(guò)域名訪問(wèn)項(xiàng)目啦捂人,例如:我把項(xiàng)目丟到/sell/下御雕,可以通過(guò)http://www.guirong.name/sell/訪問(wèn)到我的項(xiàng)目